      SUBROUTINE ID24R(P,Q,N1,M1,M2,H1,H2,A1,A2,X,Y,F,S,IERR)
         INTEGER IERR,M1,M2,N1,P,Q
         REAL A1,A2,F,H1,H2,S,X,Y
         DIMENSION F(M1,M2)
         INTEGER I,I1,IL,J,J1,J2,J3,J4,K,K1,L,L1,ML1,ML2,N,N3,NL1,NL2
         REAL B,C,D,R1,R2,RR,T1,T2,TX,TY,V1,V2,XM,XN,XX,YM,YN,YY
         DIMENSION B(8),C(8),D(4),R1(8),R2(8),RR(2),T1(8),T2(8)
       IF ((X - A1)*(A1 + (M1 - 1)*H1 - X)) 390, 10, 10
   10  CONTINUE
       IF ((Y - A2)*(A2 + (M2 - 1)*H2 - Y)) 390, 20, 20
   20  CONTINUE
       N = N1/2 + 0.1
       NL1 = 0
       ML1 = 0
       NL2 = 0
       ML2 = 0
       XX = X
       YY = Y
       IL = 0
       K = (X - A1)/H1 + 1 + 0.1E-10
       L = (Y - A2)/H2 + 1 + 0.1E-10
       L1 = L
       K1 = K
       XN = A1 + (N - 1)*H1
       XM = A1 + (M1 - N - 1)*H1
       YN = A2 + (N - 1)*H2
       YM = A2 + (M2 - N - 1)*H2
   30  CONTINUE
       C(IL+4) = S
       IF (K1 - N) 40, 50, 50
   40  CONTINUE
       X = XN
       K = N
       NL1 = NL1 + 1
       P = P + NL1 - 1
       TX = XN
   50  CONTINUE
       IF (L1 - N) 60, 70, 70
   60  CONTINUE
       Y = YN
       L = N
       NL2 = NL2 + 1
       Q = Q + NL2 - 1
       TY = YN
   70  CONTINUE
       IF (K1 - M1 + N) 90, 90, 80
   80  CONTINUE
       X = XM
       K = M1 - N
       ML1 = ML1 + 1
       P = P + ML1 - 1
       TX = XM
   90  CONTINUE
       IF (L1 - M2 + N) 110, 110, 100
  100  CONTINUE
       Y = YM
       L = M2 - N
       ML2 = ML2 + 1
       Q = Q + ML2 - 1
       TY = YM
  110  CONTINUE
       N3 = N + 1
       B(1) = 1
       IF (P + Q - 2) 140, 140, 120
  120  CONTINUE
       DO 130 I = 2, N1
          B(I) = B(I-1)*(N1 - I + 1)
  130  CONTINUE
  140  CONTINUE
       DO 190 I = 1, N
          T1(I) = X - A1 - (K - N + I - 1)*H1
          IF (N1 - P) 410, 150, 160
  150     CONTINUE
          T1(I) = B(P)
          GO TO 170
  160     CONTINUE
          T1(I) = B(P)*(T1(I)/H1)**(N1 - P)
          T2(I) = Y - A2 - (L - N + I - 1)*H2
  170     CONTINUE
          IF (N1 - Q) 420, 180, 190
  180     CONTINUE
          T2(I) = B(Q)
          GO TO 200
  190  T2(I) = B(Q)*(T2(I)/H2)**(N1 - Q)
  200  CONTINUE
       DO 250 I = N3, N1
          T1(I) = A1 + (K - N + I - 1)*H1 - X
          IF (N1 - P) 410, 210, 220
  210     CONTINUE
          T1(I) = B(P)
          GO TO 230
  220     CONTINUE
          T1(I) = B(P)*(T1(I)/H1)**(N1 - P)
          T2(I) = A2 + (L - N + I - 1)*H2 - Y
  230     CONTINUE
          IF (N1 - Q) 420, 240, 250
  240     CONTINUE
          T2(I) = B(Q)
          GO TO 260
  250  T2(I) = B(Q)*(T2(I)/H2)**(N1 - Q)
  260  CONTINUE
       D(1) = 1
       D(2) = -N1
       D(3) = (N1 - 1)*N
       D(4) = -56
       C(1) = 1
       C(2) = 4
       C(3) = 66
       C(4) = 2416
       RR(1) = C(N)*H1**(P - 1)
       RR(2) = C(N)*H2**(Q - 1)
       IF ((RR(1) .LE. 0.) .OR. (RR(2) .LE. 0.)) GO TO 400
          DO 280 I = 1, N
             I1 = N1 - I + 1
             V1 = 0
             V2 = 0
             DO 270 J = 1, I
                J1 = N - J + 1
                J2 = I - J + 1
                V1 = V1 + D(J2)*T1(J1)
                V2 = V2 + D(J2)*T2(J1)
  270        CONTINUE
             R1(I1) = V1/RR(1)
             R2(I1) = V2/RR(2)
  280     CONTINUE
          DO 300 I = 1, N
             V1 = 0
             V2 = 0
             DO 290 J = 1, I
                J3 = J + N
                J4 = I - J + 1
                V1 = V1 + D(J4)*T1(J3)
                V2 = V2 + D(J4)*T2(J3)
  290        CONTINUE
             R1(I) = (-1)**(P + 1)*V1/RR(1)
             R2(I) = (-1)**(Q + 1)*V2/RR(2)
  300     CONTINUE
          S = 0
          DO 320 I = 1, N1
             I1 = K - N + I
             DO 310 J = 1, N1
                J1 = L - N + J
                S = S + F(I1,J1)*R1(I)*R2(J)
  310        CONTINUE
  320     CONTINUE
          C(1) = 1
          C(2) = 4.0/9.0
          C(3) = (11.0/20.0)**2
          C(4) = (151.0/315.0)**2
          S = C(N)*S
          IF (IL .EQ. 1) GO TO 330
             IF (IL .EQ. 2) GO TO 340
                IF (IL .EQ. 3) GO TO 370
                   IF (IL .EQ. 4) GO TO 380
                      IF ((NL1 .EQ. 1 .OR. ML1 .EQ. 1) .AND.
     1                   (NL2 .EQ. 1 .OR. ML2 .EQ. 1)) GO TO 330
                         IF ((NL1 .EQ. 1 .OR. ML1 .EQ. 1) .OR.
     1                      (NL2 .EQ. 1 .OR. ML2 .EQ. 1)) GO TO 350
                            GO TO 440
  330                 CONTINUE
                      IL = IL + 1
                      NL2 = NL2 - 1
                      ML2 = ML2 - 1
                      IF (IL .EQ. 1) GO TO 30
                         NL1 = NL1 - 2
                         ML1 = ML1 - 2
                         NL2 = NL2 + 1
                         ML2 = ML2 + 1
                         GO TO 30
  340              CONTINUE
                   S = C(5) + C(6)*(XX - TX) + S*(YY - TY)
                   GO TO 440
  350        CONTINUE
             IF (NL1 .EQ. 1 .OR. ML1 .EQ. 1) GO TO 360
                IL = 3
                GO TO 30
  360     CONTINUE
          IL = 4
          GO TO 30
  370  CONTINUE
       S = C(7) + S*(YY - TY)
       GO TO 440
  380  CONTINUE
       S = C(8) + S*(XX - TX)
       GO TO 440
  390  CONTINUE
       IERR = 2
       GO TO 430
  400  CONTINUE
       IERR = 1
       GO TO 430
  410  CONTINUE
       IERR = 3
       GO TO 430
  420  CONTINUE
       IERR = 4
       GO TO 430
  430  CONTINUE
       IF (IERR .NE. 0) CALL UTII12(IERR,3)
  440  CONTINUE
       RETURN
      END
